Open SCAP Library: OVAL External Variable Binding

Open SCAP Library

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Files | Data Structures | Functions
OVAL External Variable Binding
OVAL

Interface to Variable model. More...

## Files
file | oval_variables.h

## Data Structures
struct | oval_variable_model
| The OVAL variable model facilitates access to external variable value bindings used to to constrain the evaluation of OVAL objects. More...
struct | oval_variable_model_iterator

## Functions
struct oval_variable_model * | oval_variable_model::oval_variable_model_new (void)
| Create a new empty OVAL variable model.
struct oval_variable_model * | oval_variable_model::oval_variable_model_import (const char *file)
| Import the content from the file into a new oval_variable_model. More...
struct oval_variable_model * | oval_variable_model::oval_variable_model_clone (struct oval_variable_model *)
| Clone an OVAL variable model. More...
void | oval_variable_model::oval_variable_model_free (struct oval_variable_model *)
| Free memory allocated to a specified oval_variable_model. More...
int | oval_variable_model::oval_variable_model_export (struct oval_variable_model *, const char *file)
| Export the specified oval_variable_model into file.

## Setters
void | oval_variable_model_set_generator (struct oval_variable_model *model, struct oval_generator *generator)
void | oval_variable_model::oval_variable_model_add (struct oval_variable_model *model, char *varid, const char *comment, oval_datatype_t datatype, char *value)
| Get the values bound to a specified external variable. More...

## Getters
struct oval_generator * | oval_variable_model_get_generator (struct oval_variable_model *model)
struct oval_string_iterator * | oval_variable_model::oval_variable_model_get_variable_ids (struct oval_variable_model *)
| Get all external variables managed by a specified oval_variable_model. More...
bool | oval_variable_model::oval_variable_model_has_variable (struct oval_variable_model *model, const char *id)
| Return true if variable with ID is present in variable model, false otherwise. More...
oval_datatype_t | oval_variable_model::oval_variable_model_get_datatype (struct oval_variable_model *, char *)
| Get a specified external variable datatype. More...
const char * | oval_variable_model::oval_variable_model_get_comment (struct oval_variable_model *, char *)
| Get a specified external variable comment. More...
struct oval_value_iterator * | oval_variable_model::oval_variable_model_get_values (struct oval_variable_model *, char *)
| Get the values bound to a specified external variable. More...

## Iterators
bool | oval_variable_model_iterator::oval_variable_model_iterator_has_more (struct oval_variable_model_iterator *)
| Returns true if iterator not exhausted.
struct oval_variable_model * | oval_variable_model_iterator::oval_variable_model_iterator_next (struct oval_variable_model_iterator *)
| Returns next instance of oval_variable_model.
void | oval_variable_model_iterator::oval_variable_model_iterator_free (struct oval_variable_model_iterator *)
| Free iterator.

## Detailed Description

Interface to Variable model.

## Function Documentation

void oval_variable_model_add | ( | struct oval_variable_model * | model,
|  | char * | varid,
|  | const char * | comment,
|  | oval_datatype_t | datatype,
|  | char * | value
| ) |  |

Get the values bound to a specified external variable.

If the varid does not resolve to a managed external variable, this method returns NULL.

Parameters

  variable_model | the specified oval_variable_model.
  varid | the identifier of the required oval_variable.

struct oval_variable_model * oval_variable_model_clone | ( | struct oval_variable_model * |  | ) |
| read

Clone an OVAL variable model.

Returns
  A copy of the specified oval_variable_model.

void oval_variable_model_free | ( | struct oval_variable_model * |  | ) |

Free memory allocated to a specified oval_variable_model.

Parameters

  variable_model | the specified oval_variable_model

const char * oval_variable_model_get_comment | ( | struct oval_variable_model * | ,
|  | char * |
| ) |  |

Get a specified external variable comment.

If the varid does not resolve to a managed external variable, this method returns NULL.

Parameters

  variable_model | the specified oval_variable_model.
  varid | the identifier of the required oval_variable.

oval_datatype_t oval_variable_model_get_datatype | ( | struct oval_variable_model * | ,
|  | char * |
| ) |  |

Get a specified external variable datatype.

If the varid does not resolve to a managed external variable, this method returns 0.

Parameters

  variable_model | the specified oval_variable_model.
  varid | the identifier of the required oval_variable.

struct oval_value_iterator * oval_variable_model_get_values | ( | struct oval_variable_model * | ,
|  | char * |
| ) |  |
| read

Get the values bound to a specified external variable.

If the varid does not resolve to a managed external variable, this method returns NULL.

Parameters

  variable_model | the specified oval_variable_model.
  varid | the identifier of the required oval_variable.

struct oval_string_iterator * oval_variable_model_get_variable_ids | ( | struct oval_variable_model * |  | ) |
| read

Get all external variables managed by a specified oval_variable_model.

Parameters

  variable_model | the specified oval_variable_model.

bool oval_variable_model_has_variable | ( | struct oval_variable_model * | model,
|  | const char * | id
| ) |  |

Return true if variable with ID is present in variable model, false otherwise.

Parameters

  model | Variable model
  id | ID of variable

struct oval_variable_model * oval_variable_model_import | ( | const char * | file | ) |
| read

Import the content from the file into a new oval_variable_model.

Parameters

  file | filename

Returns
  new oval_variable_model, or NULL if an error occurred